import { isArray } from '../../util'
import { decorate, isModel } from '../helper'

function handleDescriptor (target, name, descriptor, [Entity]) {
  return {
    ...descriptor,
    async value (...args) {
      const entity = isModel(Entity) ? Entity : this
      const res = await descriptor.value.apply(this, args)
      if (res?.data && typeof res.data === 'object') {
        const formMethod = isArray(res.data) ? 'fromDataSet' : 'fromData'
        res.data = entity[formMethod](res.data)
      }
      return res
    }
  }
}

export function result (...args) {
  return decorate(handleDescriptor, args)
}
