
declare module '@cip/utils/model' {
  interface IAnyObject{
    [propname: string]: any
  }
  type IFieldType = [Model] | Model | 'this' | ['this'] | StringConstructor | DateConstructor | NumberConstructor | BooleanConstructor
  interface IField{
    field?: string
    type?: IFieldType
    default?: any
    map?: IAnyObject
    array?: boolean
    json?:boolean
    ignoreToData?: boolean
    _renderConfig?: any
  }
  type IConfig = Record<string, IField>
  interface IModelOptions{
    part?: boolean
    ignoreEmpty?: boolean
  }
  class Model{
    constructor(config?: IConfig|'this'| ['this'],options?: IModelOptions)
    formData(data: IAnyObject): IAnyObject
  }

  export function transformData (options?: {params?: Model, result?: Model, cache?: boolean}): (target, name, descriptor)=> any

  export function bind(target, name, descriptor): any

  export default Model

}
