declare module '@cip/utils/util' {
  // 深拷贝
  export function cloneDeep<T>(params: T): T

  // 2个对象值进行比较
  export function objectEqual(objectA: Record<any, any>, objectB:  Record<any, any>): boolean

  // 节流
  export function throttle (fn: (params:any) => any, delay: number): void

  // 防抖
  export function debounce(fn: (params:any) => any, wait: number, immediate: boolean): void

  // 大写第一位字符
  export function toUpperFirstCase(str: string): string

  // 平铺数组转换为树状结构
  export function toTreeData(list: any[], parentKey: string = 'parentId', root: number = 0): boolean

  // 判断值是否为undefined或null
  export function isEmpty(value: any): boolean

  // 判断值是否为undefined或null或空字符串
  export function isInputEmpty(value: any): boolean

  // 判断值是否不为undefined或null
  export function isNotEmpty(value: any): boolean

  // 是否为没有空对象
  export function isEmptyObject(value: any): boolean

  // 判断值是否为数组
  export function isArray(value: any): boolean

  // 判断是否对象
  export function isObject(value: any): boolean

  // 判断是否为字符串
  export function isString(value: any): boolean

  // 判断是否为数字
  export function isNumber(value: any): boolean

  // 判断值是否为JSON String
  export function isJson(value: any): boolean

  // 判断值是否为Map类型
  export function isMap(value: any): boolean

  // 下载文件
  export function downloadFile(href: string, filename: string): void

  // 返回下一条数据
  export function getNextItem<T>(itemList: T[], index: number): T

  // 耗时格式化
  export function durationTimeFormat(ms: number): string

  // 根据url获取query中key对应的值
  export function getQueryString(key: string, url: string): string | null

  // 拼接url和query的值
  export function setUrlQuery(url: string, query: string): string

  // 根据 label获取 value
  interface IOptionProps {
    label: string, // label键值
    value: string // value键值
  }
  export function getLabelByValue(value: any, options: any[], optionProps: IOptionProps): string

  export function getFieldValue(target: Record<string, any>, propertyName: string): any

  // 向对象添加一个property
  export function setFieldValue(target: Record<string, any>, propertyName: string, value: any, hasArray: boolean = false): void

  // 根据key获取mapping中的value
  export function getValueByKey(key: any, mapping: Map<any, any>): any

  // 根据value获取mapping中的key
  export function getKeyByValue(value: any, mapping: Map<any, any>): any

  // 值根据映射关系和方向进行转换
  export function getValueMapping(value: any, mapping: Record<string, any> = {}, valueType): any

  export function depthFirstSearchTree(tree: Record<string, any>, value: any, key: string, children: string = 'children', depth: number = 0): Record<string, any>

  export function getUsingConfig<T>(...arg: T[]): T

  export function getEquipmentType(): 'mobile' | 'pc'

  // 数字添加千分位分隔符
  export function addThousandSeparator(number: number, separator: string = ''): string

  export function getValueByTemplate<T>(template: string, object: Record<string, T>): T
}
